#include "average.h"

AVERAGE_REPLYPTR calculate_average (TREEPTR Tree)
{
	/* DHLWSH STATHERWN */
	const int plh8os_kormou = 24;
	const int plh8os_basika = 5;
	const int plh8os_epiloghs = 11;
	const int plh8os_ptyxiakhs = 1;
	const double syntelesths_kormou = 2.0, syntelesths_basikwn = 2.0, syntelesths_epiloghs = 1.5;
	const double syntelesths_ptyxiakhs = 6.0;

	/* DHLWSH METABLHTWN */
	TREE_NODEPTR current_node;							// Running node in tree.
	LISTPTR lista_ypoxrewtikwn = LIST__Initialize ();	// List with "YP" lessons.
	LISTPTR lista_BK_1 = LIST__Initialize ();			// List with "BK" lessons (1st Section).
	LISTPTR lista_BK_2 = LIST__Initialize ();			// List with "BK" lessons (2nd Section).
	LISTPTR lista_BK_3 = LIST__Initialize ();			// List with "BK" lessons (3rd Section).
	LISTPTR lista_epiloghs = LIST__Initialize ();		// List with "EP" lessons.
	/* DHLWSH METABLHTWN */
	double current_grade, ptyxiakh_grade = 0.0;
	int ptyxiakh = 0;
	char enter [REPLY_BUFFER];

	/* Reserve memory for average grade */
	AVERAGE_REPLYPTR average = (AVERAGE_REPLYPTR) malloc (sizeof (AVERAGE_REPLY));
	average->prwtos_tomeas = (AVERAGE_PROPERTIESPTR) malloc (sizeof (AVERAGE_PROPERTIES));
	average->deyteros_tomeas = (AVERAGE_PROPERTIESPTR) malloc (sizeof (AVERAGE_PROPERTIES));
	average->tritos_tomeas = (AVERAGE_PROPERTIESPTR) malloc (sizeof (AVERAGE_PROPERTIES));
	average->uniform = (AVERAGE_PROPERTIESPTR) malloc (sizeof (AVERAGE_PROPERTIES));
	
	/*************************************************************************/


	/****************************************************************************************\
	* May be there is a bug if someone uses this function and hasn't passed a single Lesson  *
	\****************************************************************************************/


	/* CLASSIFY LESSONS IN LISTS */
	current_node = TREE__Minimum (Tree, Tree->ROOT);
	while (current_node != Tree->NIL) {
		current_grade = current_node->data->grade;
		if (strcmp(current_node->data->barythta, "YP") == 0) {
			LIST__Insert_node_at_front (lista_ypoxrewtikwn, current_node->data->code, current_node);
		}
		else if (strcmp(current_node->data->barythta, "BK") == 0) {
			switch (current_node->data->section) {
				case 1:
					LIST__Insert_node_at_front (lista_BK_1, current_node->data->code, current_node);
					break;
				
				case 2:
					LIST__Insert_node_at_front (lista_BK_2, current_node->data->code, current_node);
					break;
				
				case 3:
					LIST__Insert_node_at_front (lista_BK_3, current_node->data->code, current_node);
					break;
				
				default:
					printf ("\n\nError in node with KEY: %ld.\a\n", current_node->key);
					printf ("Press Enter key to continue...");
					fflush (stdout);
					fflush (stdin);
					fgets (enter, REPLY_BUFFER, stdin);
					break;
			}
		}
		else if (strcmp(current_node->data->barythta, "EP") == 0) {
			LIST__Insert_node_at_front (lista_epiloghs, current_node->data->code, current_node);
		}
		else if (strcmp(current_node->data->barythta, "PT") == 0) {
			ptyxiakh++;
			ptyxiakh_grade = current_grade;
		}
		else {
			printf ("\nError in node with KEY: %ld.\a\n", current_node->key);
			printf ("Press Enter key to continue...");
			fflush (stdout);
			fflush (stdin);
			fgets (enter, REPLY_BUFFER, stdin);
		}
		current_node = TREE__Successor (Tree, current_node);	// Procceed to next node
	}

	/* ENTERING CALCULATION PROCEDURE */

	/* Uniform Average Grade */
	calculate_average_following_certain_section (0, average->uniform, lista_ypoxrewtikwn,
													lista_BK_1, lista_BK_2, lista_BK_3,
													lista_epiloghs, ptyxiakh, ptyxiakh_grade);
	
	/* Average Grade based on 1st Section */
	calculate_average_following_certain_section (1, average->prwtos_tomeas, lista_ypoxrewtikwn,
													lista_BK_1, lista_BK_2, lista_BK_3,
													lista_epiloghs, ptyxiakh, ptyxiakh_grade);

	/* Average Grade based on 2nd Section */
	calculate_average_following_certain_section (2, average->deyteros_tomeas, lista_ypoxrewtikwn,
													lista_BK_1, lista_BK_2, lista_BK_3,
													lista_epiloghs, ptyxiakh, ptyxiakh_grade);

	/* Average Grade based on 3rd Section */
	calculate_average_following_certain_section (3, average->tritos_tomeas, lista_ypoxrewtikwn,
													lista_BK_1, lista_BK_2, lista_BK_3,
													lista_epiloghs, ptyxiakh, ptyxiakh_grade);

	/* Dealloccate unused memory */
	LIST__Destroy (lista_ypoxrewtikwn);
	LIST__Destroy (lista_BK_1);
	LIST__Destroy (lista_BK_2);
	LIST__Destroy (lista_BK_3);

	return average;		// Return average grade.
}

/* Average Grade based on certain Section */
int calculate_average_following_certain_section (const int section, AVERAGE_PROPERTIESPTR average, 
										LISTPTR ypoxrewtika, LISTPTR BK_1, LISTPTR BK_2, LISTPTR BK_3,
										LISTPTR epiloghs, const int ptyxiakh, double ptyxiakh_grade)
{
	/* STATHERES */
	const double	syntelesths_kormou = 2.0, syntelesths_basikwn = 2.0, 
					syntelesths_epiloghs = 1.5, syntelesths_ptyxiakhs = 6.0;
	const int		plh8os_kormou = 24, plh8os_basika = 5, plh8os_epiloghs = 11;

	/* METABLHTES */
	LISTPTR lista_tomea = LIST__Initialize ();
	LISTPTR temp_list1, temp_list2, temp_list3, temp_list4, temp_list5, synolika_epiloghs;
	LIST_NODEPTR current_list_node;
	KEY_TYPE temp_key;
	double current_grade;
	double low_arithmiths, low_paronomasths, high_arithmiths, high_paronomasths;
	int i, counter_kormou = 0, counter_basika = 0, counter_epiloghs = 0;
	/* END OF DECLARATIONS */

	/* Initializations */
	average->arithmiths = 0.0;
	average->paronomasths = 0.0;
	average->average_grade = 0.0;
	average->get_ptyxio = 0;
	average->highest_grade = 0.0;
	average->lowest_grade = 0.0;
	for (i = 1; i <= 11; i++) {
		if (i <= 5)
			average->basika [i - 1] = 0;
		average->epiloghs [i - 1] = 0;
	}
	/* END OF Initializations */

	/* Get on with "YP" Lessons */
	if (ypoxrewtika->NUMBER_OF_ELEMENTS > 0) {
		current_list_node = ypoxrewtika->HEAD;
		while (current_list_node != ypoxrewtika->NIL) {
			current_grade = current_list_node->lesson_node->data->grade;
			average->arithmiths += (double) syntelesths_kormou * current_grade;
			average->paronomasths += syntelesths_kormou;
			counter_kormou++;		// Increment counter.
			current_list_node = current_list_node->next;
		}
	}

	/* Get on with "PT" Lesson (PTYXIAKH) */
	if (ptyxiakh) {
		average->arithmiths += (double) syntelesths_ptyxiakhs * ptyxiakh_grade;
		average->paronomasths += syntelesths_ptyxiakhs;
	}

	/* Get on with "BK" Lessons that will be counted as BASIC LESSONS */
	switch (section) {
		case 1:
			/* 1st Section */

			current_list_node = BK_1->HEAD;
			while (current_list_node != BK_1->NIL) {
				LIST__Insert_node_at_front (lista_tomea, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Sort elements in DECREASING ORDER of grades */
			LIST__BubbleSort (lista_tomea);

			/* current_list_node = HEAD of lista tomea => Highest grade */
			current_list_node = lista_tomea->HEAD;
			if (lista_tomea->NUMBER_OF_ELEMENTS > 5) {
				for (i = 1; i <= 5; i++) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i - 1] = temp_key;		/* Indicate key used */
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			else {
				current_list_node = lista_tomea->HEAD;
				i = 0;
				while (current_list_node != lista_tomea->NIL) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i] = temp_key;			/* Indicate key used */
					i++;
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			temp_list1 = LIST__Union (BK_2, BK_3);
			temp_list2 = LIST__Union (temp_list1, lista_tomea);
			synolika_epiloghs = LIST__Union (temp_list2, epiloghs);

			/* Free up temp memory used */
			LIST__Destroy (temp_list1);
			LIST__Destroy (temp_list2);
			LIST__Destroy (lista_tomea);

			break;

		case 2:
			/* 2nd Section */

			current_list_node = BK_2->HEAD;
			while (current_list_node != BK_2->NIL) {
				LIST__Insert_node_at_front (lista_tomea, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Sort elements in DECREASING ORDER of grades */
			LIST__BubbleSort (lista_tomea);

			/* current_list_node = HEAD of lista tomea => Highest grade */
			current_list_node = lista_tomea->HEAD;
			if (lista_tomea->NUMBER_OF_ELEMENTS > 5) {
				for (i = 1; i <= 5; i++) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i - 1] = temp_key;		/* Indicate key used */
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			else {
				current_list_node = lista_tomea->HEAD;
				i = 0;
				while (current_list_node != lista_tomea->NIL) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i] = temp_key;			/* Indicate key used */
					i++;
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			temp_list1 = LIST__Union (BK_1, BK_3);
			temp_list2 = LIST__Union (temp_list1, lista_tomea);
			synolika_epiloghs = LIST__Union (temp_list2, epiloghs);

			/* Free up temp memory used */
			LIST__Destroy (temp_list1);
			LIST__Destroy (temp_list2);
			LIST__Destroy (lista_tomea);

			break;

		case 3:
			/* 3rd Section */

			current_list_node = BK_3->HEAD;
			while (current_list_node != BK_3->NIL) {
				LIST__Insert_node_at_front (lista_tomea, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Sort elements in DECREASING ORDER of grades */
			LIST__BubbleSort (lista_tomea);

			/* current_list_node = HEAD of lista tomea => Highest grade */
			current_list_node = lista_tomea->HEAD;
			if (lista_tomea->NUMBER_OF_ELEMENTS > 5) {
				for (i = 1; i <= 5; i++) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i - 1] = temp_key;		/* Indicate key used */
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			else {
				current_list_node = lista_tomea->HEAD;
				i = 0;
				while (current_list_node != lista_tomea->NIL) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [i] = temp_key;			/* Indicate key used */
					i++;
					counter_basika++;						/* Increment counter */
					LIST__Delete_node_according_to_key (lista_tomea, temp_key);
					current_list_node = lista_tomea->HEAD;
				}
			}
			temp_list1 = LIST__Union (BK_1, BK_2);
			temp_list2 = LIST__Union (temp_list1, lista_tomea);
			synolika_epiloghs = LIST__Union (temp_list2, epiloghs);

			/* Free up temp memory used */
			LIST__Destroy (temp_list1);
			LIST__Destroy (temp_list2);
			LIST__Destroy (lista_tomea);

			break;

		default:
			/* Uniform */

			/* Place 1st section Lessons in temp_list1 */
			temp_list1 = LIST__Initialize ();
			current_list_node = BK_1->HEAD;
			while (current_list_node != BK_1->NIL) {
				LIST__Insert_node_at_front (temp_list1, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Place 2nd section Lessons in temp_list2 */
			temp_list2 = LIST__Initialize ();
			current_list_node = BK_2->HEAD;
			while (current_list_node != BK_2->NIL) {
				LIST__Insert_node_at_front (temp_list2, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Place 3rd section Lessons in temp_list3 */
			temp_list3 = LIST__Initialize ();
			current_list_node = BK_3->HEAD;
			while (current_list_node != BK_3->NIL) {
				LIST__Insert_node_at_front (temp_list3, 
											current_list_node->key_code, 
											current_list_node->lesson_node);
				current_list_node = current_list_node->next;
			}

			/* Sort elements in DECREASING ORDER of grades */
			LIST__BubbleSort (temp_list1);
			LIST__BubbleSort (temp_list2);
			LIST__BubbleSort (temp_list3);

			/* Place 1st section Lesson with highest grade in average */
			if (temp_list1->NUMBER_OF_ELEMENTS > 0) {
				average->arithmiths += (double) syntelesths_basikwn * (temp_list1->HEAD->lesson_node->data->grade);
				average->paronomasths += syntelesths_basikwn;
				temp_key = temp_list1->HEAD->key_code;
				average->basika [counter_basika] = temp_key;	/* Indicate key used */
				counter_basika++;								/* Increment counter */
				LIST__Delete_node_according_to_key (temp_list1, temp_key);
			}

			/* Place 2nd section Lesson with highest grade in average */
			if (temp_list2->NUMBER_OF_ELEMENTS > 0) {
				average->arithmiths += (double) syntelesths_basikwn * (temp_list2->HEAD->lesson_node->data->grade);
				average->paronomasths += syntelesths_basikwn;
				temp_key = temp_list2->HEAD->key_code;
				average->basika [counter_basika] = temp_key;	/* Indicate key used */
				counter_basika++;								/* Increment counter */
				LIST__Delete_node_according_to_key (temp_list2, temp_key);
			}

			/* Place 3rd section Lesson with highest grade in average */
			if (temp_list3->NUMBER_OF_ELEMENTS > 0) {
				average->arithmiths += (double) syntelesths_basikwn * (temp_list3->HEAD->lesson_node->data->grade);
				average->paronomasths += syntelesths_basikwn;
				temp_key = temp_list3->HEAD->key_code;
				average->basika [counter_basika] = temp_key;	/* Indicate key used */
				counter_basika++;								/* Increment counter */
				LIST__Delete_node_according_to_key (temp_list3, temp_key);
			}

			/* Take the Union of all "BK" Lessons */
			temp_list4 = LIST__Union (temp_list1, temp_list2);
			temp_list5 = LIST__Union (temp_list3, temp_list4);
			
			/* Sort elements in DECREASING ORDER of grades */
			LIST__BubbleSort (temp_list5);

			/* current_list_node = HEAD of temp_list5 => Highest grade in rest Union */
			current_list_node = temp_list5->HEAD;
			if (temp_list5->NUMBER_OF_ELEMENTS > 2) {
				for (i = 1; i <= 2; i++) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [counter_basika] = temp_key;	/* Indicate key used */
					counter_basika++;								/* Increment counter */
					LIST__Delete_node_according_to_key (temp_list5, temp_key);
					current_list_node = temp_list5->HEAD;
				}
			}
			else {
				current_list_node = temp_list5->HEAD;
				while (current_list_node != temp_list5->NIL) {
					average->arithmiths += (double) syntelesths_basikwn * (current_list_node->lesson_node->data->grade);
					average->paronomasths += syntelesths_basikwn;
					temp_key = current_list_node->key_code;
					average->basika [counter_basika] = temp_key;	/* Indicate key used */
					counter_basika++;								/* Increment counter */
					LIST__Delete_node_according_to_key (temp_list5, temp_key);
					current_list_node = temp_list5->HEAD;
				}
			}
			
			synolika_epiloghs = LIST__Union (temp_list5, epiloghs);

			/* Free up temp memory used */
			LIST__Destroy (temp_list1);
			LIST__Destroy (temp_list2);
			LIST__Destroy (temp_list3);
			LIST__Destroy (temp_list4);
			LIST__Destroy (temp_list5);

			break;
	}

	/* Get on with "EP" Lessons or "BK" Lessons that will be counted as "EP" LESSONS */

	/* Sort elements in DECREASING ORDER of grades */
	LIST__BubbleSort (synolika_epiloghs);

	/* current_list_node = HEAD of synolika_epiloghs => Highest grade */
	current_list_node = synolika_epiloghs->HEAD;
	if (synolika_epiloghs->NUMBER_OF_ELEMENTS > 11) {
		for (i = 1; i <= 11; i++) {
			average->arithmiths += (double) syntelesths_epiloghs * (current_list_node->lesson_node->data->grade);
			average->paronomasths += syntelesths_epiloghs;
			temp_key = current_list_node->key_code;
			average->epiloghs [i - 1] = temp_key;		/* Indicate key used */
			counter_epiloghs++;							/* Increment counter */
			LIST__Delete_node_according_to_key (synolika_epiloghs, temp_key);
			current_list_node = synolika_epiloghs->HEAD;
		}
	}
	else {
		current_list_node = synolika_epiloghs->HEAD;
		i = 0;
		while (current_list_node != synolika_epiloghs->NIL) {
			average->arithmiths += (double) syntelesths_epiloghs * (current_list_node->lesson_node->data->grade);
			average->paronomasths += syntelesths_epiloghs;
			temp_key = current_list_node->key_code;
			average->epiloghs [i] = temp_key;			/* Indicate key used */
			i++;
			counter_epiloghs++;							/* Increment counter */
			LIST__Delete_node_according_to_key (synolika_epiloghs, temp_key);
			current_list_node = synolika_epiloghs->HEAD;
		}
	}

	/* Calculate average */
	average->average_grade = (double) (average->arithmiths / average->paronomasths);



	/* Free up temp memory used */
	LIST__Destroy (synolika_epiloghs);



	if ((counter_kormou == plh8os_kormou) && (counter_basika == plh8os_basika) && 
		(counter_epiloghs == plh8os_epiloghs)) {
		/* MPOREIS NA PAREIS PTYXIO */
		average->get_ptyxio = 1;
	}
	else {
		/* DEN MPOREIS NA PAREIS AKOMA PTYXIO */
		average->get_ptyxio = 0;
	}


	/*
	 * Akolou8oun oi prakseis gia problepsh
	 * oriwn tou bathmou toy ptyxiou.
	 */


	low_arithmiths = 0.0;
	low_paronomasths = 0.0;
	high_arithmiths = 0.0;
	high_paronomasths = 0.0;

	if (counter_kormou < plh8os_kormou) {
		for (i = 1; i <= (plh8os_kormou - counter_kormou); i++) {
			low_arithmiths += (double) syntelesths_kormou * 5;
			low_paronomasths += (double) syntelesths_kormou;
			high_arithmiths += (double) syntelesths_kormou * 10;
			high_paronomasths += (double) syntelesths_kormou;
		}
	}

	if (counter_basika < plh8os_basika) {
		for (i = 1; i <= (plh8os_basika - counter_basika); i++) {
			low_arithmiths += (double) syntelesths_basikwn * 5;
			low_paronomasths += (double) syntelesths_basikwn;
			high_arithmiths += (double) syntelesths_basikwn * 10;
			high_paronomasths += (double) syntelesths_basikwn;
		}
	}

	if (counter_epiloghs < plh8os_epiloghs) {
		for (i = 1; i <= (plh8os_epiloghs - counter_epiloghs); i++) {
			low_arithmiths += (double) syntelesths_epiloghs * 5;
			low_paronomasths += (double) syntelesths_epiloghs;
			high_arithmiths += (double) syntelesths_epiloghs * 10;
			high_paronomasths += (double) syntelesths_epiloghs;
		}
	}

	if (!ptyxiakh) {
		/* EVERYONE GETS A TEN "10" IN PTYXIAKH */
		low_arithmiths += (double) syntelesths_ptyxiakhs * 10;
		low_paronomasths += (double) syntelesths_ptyxiakhs;
		high_arithmiths += (double) syntelesths_ptyxiakhs * 10;
		high_paronomasths += (double) syntelesths_ptyxiakhs;
	}

	average->lowest_grade = (double) (average->arithmiths + low_arithmiths) / (average->paronomasths + low_paronomasths);
	average->highest_grade = (double) (average->arithmiths + high_arithmiths) / (average->paronomasths + high_paronomasths);

	/* END OF ALL CALCULATIONS */

	return 1;	// Indicate successful calculation.
}

int stroggylopoihsh (double number)
{
	int arithmos;
	double apotelesma;
	int akeraio, ypoloipo;

	arithmos = (int) floor (number);

	apotelesma = number * 10;
	akeraio = (int) floor (apotelesma);
	ypoloipo = akeraio % 10;
	if (ypoloipo >= 5)
		return (arithmos + 1);
	else
		return arithmos;
}

double calculate_period_average (TREEPTR Tree, KEY_TYPE period [ARRAY_SIZE])
{
	const double syntelesths_kormou = 2.0, syntelesths_basika = 2.0,
				syntelesths_epiloghs = 1.5, syntelesths_ptyxiakhs = 6.0;
	double arithmiths, paronomasths;
	char barythta [BARYTHTA_BUFFER];
	int i;
	KEY_TYPE key;
	TREE_NODEPTR current;

	arithmiths = 0.0;
	paronomasths = 0.0;
	i = 0;
	while (period [i] != 0) {
		key = period [i];
		current = TREE__Search (Tree, key);
		strcpy (barythta, current->data->barythta);
		if (strcmp (barythta, "YP") == 0) {
			arithmiths += (double) syntelesths_kormou * current->data->grade;
			paronomasths += (double) syntelesths_kormou;
		}
		if (strcmp (barythta, "BK") == 0) {
			arithmiths += (double) syntelesths_basika * current->data->grade;
			paronomasths += (double) syntelesths_basika;
		}
		if (strcmp (barythta, "EP") == 0) {
			arithmiths += (double) syntelesths_epiloghs * current->data->grade;
			paronomasths += (double) syntelesths_epiloghs;
		}
		if (strcmp (barythta, "PT") == 0) {
			arithmiths += (double) syntelesths_ptyxiakhs * current->data->grade;
			paronomasths += (double) syntelesths_ptyxiakhs;
		}

		i++;	// Go to next lesson.
	}

	if (i == 0)
		return 0.0;	// Indicate no average grade;

	return (double) arithmiths / paronomasths;
}

void manage_average_fluctuation (TREEPTR Tree, LISTPTR period, 
								 FLUCTUATION_AVERAGEPTR average, const int tomeas)
{
	const double syntelesths_kormou = 2.0, syntelesths_basika = 2.0,
				syntelesths_epiloghs = 1.5, syntelesths_ptyxiakhs = 6.0;

	LIST_NODEPTR current_list_node = period->HEAD;
	TREE_NODEPTR current_tree_node;
	KEY_TYPE key;
	char barythta [BARYTHTA_BUFFER];

	while (current_list_node != period->NIL) {
		current_tree_node = current_list_node->lesson_node;
		key = current_list_node->key_code;
		strcpy (barythta, current_tree_node->data->barythta);
		if (strcmp (barythta, "YP") == 0) {
			/* The program does not allow duplicate copies of the same Lesson (Tree) */
			/* So we don't have to check what List_Insert_bla_bla () returns!        */
			LIST__Insert_node_at_front (average->ypoxrewtika, key, current_tree_node);
			average->arithmiths += (double) syntelesths_kormou * current_tree_node->data->grade;
			average->paronomasths += (double) syntelesths_kormou;
			average->number_of_lessons++;
		}
		if (strcmp (barythta, "PT") == 0) {
			/* The program does not allow duplicate copies of the same Lesson (Tree) */
			/* So we don't have to check what List_Insert_bla_bla () returns!        */
			LIST__Insert_node_at_front (average->ptyxiakh, key, current_tree_node);
			average->arithmiths += (double) syntelesths_ptyxiakhs * current_tree_node->data->grade;
			average->paronomasths += (double) syntelesths_ptyxiakhs;
			average->number_of_lessons++;
		}
		if (strcmp (barythta, "EP") == 0) {
			/*****************************************************************\
			* NOTE: Consider what happens if                                  *
			*       average->epiloghs->NUMBER_OF_LESSONS exceeds 11!          *
			\*****************************************************************/

			insert_epiloghs_average_fluctuation (average, current_list_node);
		}
		if (strcmp (barythta, "BK") == 0) {
			/******************************************************************\
			* ATTENTION: This is the most difficult! The lesson must be       *
			* ---------- encountered as "BK" IF AND ONLY IF it fits on the    *
			*            certain section "tomeas" and moreover there must be  *
			*            enough space in average->basika List to hold it.     *
			*            Do not allow the previous list to be larger than 5,  *
			*            or allow this lesson to fit in list if another one   *
			*            with smaller grade can leave the list.               *
			*  * NOTE 1: If something leaves from "basics" list will it enter *
			*            "epiloghs" list or will not be counted at all in the *
			*            overall average grade?                               *
			*  * NOTE 2: Consider the special case of "tomeas == 0"           *
			*            (UNIFORM GRADUATION).                                *
			\*****************************************************************/

			insert_basiko_average_fluctuation (average, current_list_node, tomeas);
		}

		current_list_node = current_list_node->next;	/* Procceed to next node */
	}

	if (average->number_of_lessons > 0)
		average->average_grade = (double) (average->arithmiths / average->paronomasths);
	else
		average->average_grade = 0.0;

}

void insert_basiko_average_fluctuation (FLUCTUATION_AVERAGEPTR average, LIST_NODEPTR current_list_node, 
										const int tomeas)
{
	/******************************************************************\
	* ATTENTION: This is the most difficult! The lesson must be       *
	* ---------- encountered as "BK" IF AND ONLY IF it fits on the    *
	*            certain section "tomeas" and moreover there must be  *
	*            enough space in average->basika List to hold it.     *
	*            Do not allow the previous list to be larger than 5,  *
	*            or allow this lesson to fit in list if another one   *
	*            with smaller grade can leave the list.               *
	*  * NOTE 1: If something leaves from "basics" list will it enter *
	*            "epiloghs" list or will not be counted at all in the *
	*            overall average grade?                               *
	*  * NOTE 2: Consider the special case of "tomeas == 0"           *
	*            (UNI-SECTION GRADUATION).                            *
	\*****************************************************************/

	const double syntelesths_basika = 2.0;

	LIST_NODEPTR temp_list_node;
	TREE_NODEPTR current_tree_node, temp_tree_node;
	KEY_TYPE key;
	int i;
	double grade;
	char enter [REPLY_BUFFER];
	LISTPTR temp_list, temp_list2;
	LISTPTR lista_BK_1 = LIST__Initialize ();			// List with "BK" lessons (1st Section).
	LISTPTR lista_BK_2 = LIST__Initialize ();			// List with "BK" lessons (2nd Section).
	LISTPTR lista_BK_3 = LIST__Initialize ();			// List with "BK" lessons (3rd Section).

	/******************************************************************************************/

	current_tree_node = current_list_node->lesson_node;
	key = current_list_node->key_code;

	switch (tomeas) {
		case 0:
			/**********************************************\
			*         Case Uni-Section Graduation          *
			************************************************
			* We must have at least one from each section! *
			\**********************************************/

			if (average->basika->NUMBER_OF_ELEMENTS < 3) {
				LIST__Insert_node_at_front (average->basika, key, current_tree_node);
				average->arithmiths += (double) syntelesths_basika * current_tree_node->data->grade;
				average->paronomasths += (double) syntelesths_basika;
				average->number_of_lessons++;
			}
			else {
				/* Separate Lessons in lists according to their section */
				temp_list_node = average->basika->HEAD;
				while (temp_list_node != average->basika->NIL) {
					temp_tree_node = temp_list_node->lesson_node;
					switch (temp_list_node->lesson_node->data->section) {
						case 1:
							LIST__Insert_node_at_front (lista_BK_1, temp_list_node->key_code, temp_tree_node);
							break;
						
						case 2:
							LIST__Insert_node_at_front (lista_BK_2, temp_list_node->key_code, temp_tree_node);
							break;
						
						case 3:
							LIST__Insert_node_at_front (lista_BK_3, temp_list_node->key_code, temp_tree_node);
							break;
						
						default:
							printf ("\n\nError in node with KEY: %ld.\a\n", temp_list_node->key_code);
							printf ("Press Enter key to continue...");
							fflush (stdout);
							fflush (stdin);
							fgets (enter, REPLY_BUFFER, stdin);
							break;
					}
					
					average->arithmiths -= (double) syntelesths_basika * temp_list_node->lesson_node->data->grade;
					average->paronomasths -= (double) syntelesths_basika;
					average->number_of_lessons--;
					LIST__Delete_node_according_to_key (average->basika, temp_list_node->key_code);

					temp_list_node = average->basika->HEAD;
				}

				/* Add newly arrived "BK" Lesson in appropriate list. */
				switch (current_tree_node->data->section) {
					case 1:
						LIST__Insert_node_at_front (lista_BK_1, current_tree_node->key, current_tree_node);
						break;
						
					case 2:
						LIST__Insert_node_at_front (lista_BK_2, current_tree_node->key, current_tree_node);
						break;
						
					case 3:
						LIST__Insert_node_at_front (lista_BK_3, current_tree_node->key, current_tree_node);
						break;
						
					default:
						printf ("\n\nError in node with KEY: %ld.\a\n", current_tree_node->key);
						printf ("Press Enter key to continue...");
						fflush (stdout);
						fflush (stdin);
						fgets (enter, REPLY_BUFFER, stdin);
						break;
				}

				/* Sort all lists */
				LIST__BubbleSort (lista_BK_1);
				LIST__BubbleSort (lista_BK_2);
				LIST__BubbleSort (lista_BK_3);

				/****************************************\
				* Create from scratch the "basika" list. *
				\****************************************/

				/* Place 1st section Lesson with highest grade in average */
				if (lista_BK_1->NUMBER_OF_ELEMENTS > 0) {
					average->arithmiths += (double) syntelesths_basika * (lista_BK_1->HEAD->lesson_node->data->grade);
					average->paronomasths += syntelesths_basika;
					LIST__Insert_node_at_front (average->basika, lista_BK_1->HEAD->key_code, lista_BK_1->HEAD->lesson_node);
					average->number_of_lessons++;					/* Increment counter */
					LIST__Delete_node_according_to_key (lista_BK_1, lista_BK_1->HEAD->key_code);
				}

				/* Place 2nd section Lesson with highest grade in average */
				if (lista_BK_2->NUMBER_OF_ELEMENTS > 0) {
					average->arithmiths += (double) syntelesths_basika * (lista_BK_2->HEAD->lesson_node->data->grade);
					average->paronomasths += syntelesths_basika;
					LIST__Insert_node_at_front (average->basika, lista_BK_2->HEAD->key_code, lista_BK_2->HEAD->lesson_node);
					average->number_of_lessons++;					/* Increment counter */
					LIST__Delete_node_according_to_key (lista_BK_2, lista_BK_2->HEAD->key_code);
				}

				/* Place 3rd section Lesson with highest grade in average */
				if (lista_BK_3->NUMBER_OF_ELEMENTS > 0) {
					average->arithmiths += (double) syntelesths_basika * (lista_BK_3->HEAD->lesson_node->data->grade);
					average->paronomasths += syntelesths_basika;
					LIST__Insert_node_at_front (average->basika, lista_BK_3->HEAD->key_code, lista_BK_3->HEAD->lesson_node);
					average->number_of_lessons++;					/* Increment counter */
					LIST__Delete_node_according_to_key (lista_BK_3, lista_BK_3->HEAD->key_code);
				}

				/* Take the Union of all "BK" Lessons */
				temp_list = LIST__Union (lista_BK_1, lista_BK_2);
				temp_list2 = LIST__Union (temp_list, lista_BK_3);
				
				/* Sort elements in DECREASING ORDER of grades */
				LIST__BubbleSort (temp_list2);

				/* temp_list_node = HEAD of temp_list2 => Highest grade in rest Union */
				temp_list_node = temp_list2->HEAD;
				if (temp_list2->NUMBER_OF_ELEMENTS > 2) {
					for (i = 1; i <= 2; i++) {
						average->arithmiths += (double) syntelesths_basika * (temp_list_node->lesson_node->data->grade);
						average->paronomasths += syntelesths_basika;
						LIST__Insert_node_at_front (average->basika, temp_list_node->key_code, temp_list_node->lesson_node);
						average->number_of_lessons++;				/* Increment counter */
						LIST__Delete_node_according_to_key (temp_list2, temp_list_node->key_code);
						temp_list_node = temp_list2->HEAD;
					}
				}
				else {
					temp_list_node = temp_list2->HEAD;
					while (temp_list_node != temp_list2->NIL) {
						average->arithmiths += (double) syntelesths_basika * (temp_list_node->lesson_node->data->grade);
						average->paronomasths += syntelesths_basika;
						LIST__Insert_node_at_front (average->basika, temp_list_node->key_code, temp_list_node->lesson_node);
						average->number_of_lessons++;				/* Increment counter */
						LIST__Delete_node_according_to_key (temp_list2, temp_list_node->key_code);
						temp_list_node = temp_list2->HEAD;
					}
				}

				/* Last case is: The list temp_list2 might not be empty. */
				/* That lesson should be encountered as "EP" Lesson. */
				if (temp_list2->HEAD != temp_list2->NIL) {
					insert_epiloghs_average_fluctuation (average, temp_list2->HEAD);
					LIST__Delete_node_according_to_key (temp_list2, temp_list2->HEAD->key_code);
				}

				if (temp_list2->HEAD != temp_list2->NIL) {
					printf ("\n\n");
					printf ("Fluctuation Average (Insert Basiko): Severe Error in your thoughts!\a\n");
					printf ("Press Enter key to continue...");
					fflush (stdout);
					fflush (stdin);
					fgets (enter, REPLY_BUFFER, stdin);
				}

				/* Free up temp memory used */
				LIST__Destroy (temp_list);
				LIST__Destroy (temp_list2);

			}
			break;
		
		default:
			/* We have specifically selected a section (1, 2, 3) */
			if (current_tree_node->data->section == tomeas) {
				/* We have a "BK" Lesson in the correct section */
				if (average->basika->NUMBER_OF_ELEMENTS < 5) {
					LIST__Insert_node_at_front (average->basika, key, current_tree_node);
					average->arithmiths += (double) syntelesths_basika * current_tree_node->data->grade;
					average->paronomasths += (double) syntelesths_basika;
					average->number_of_lessons++;
				}
				else {
					/* average->basika->NUMBER_OF_ELEMENTS == 5 */
					grade = current_tree_node->data->grade;
					temp_list_node = average->basika->HEAD;
					while (temp_list_node != average->basika->NIL) {
						if (temp_list_node->lesson_node->data->grade < grade)
							break;
						temp_list_node = temp_list_node->next;
					}

					if (temp_list_node != average->basika->NIL) {
						/* We found a lesson with smaller grade */
						/* Now we have to throw away that "BK" Lesson from "basika" list and place */
						/* it in "epiloghs" list if it has the appropriate specifications. */
						insert_epiloghs_average_fluctuation (average, temp_list_node);

						/* Delete that node from "basika" list */
						LIST__Delete_node_according_to_key (average->basika, temp_list_node->key_code);
								
						/* Insert node with higher grade in "basika" list */
						LIST__Insert_node_at_front (average->basika, key, current_tree_node);
						average->arithmiths -= (double) syntelesths_basika * temp_list_node->lesson_node->data->grade;
						average->arithmiths += (double) syntelesths_basika * grade;
						/* average->basika->NUMBER_OF_ELEMENTS = UNCHANGED = 5 */
						/* average->number_of_lessons */
					}
					else {
						/* The newly arrived "BK" lesson has poor grade. */
						/* So we will add it in "epiloghs" list if it    */
						/* has the appropriate specs. */
						insert_epiloghs_average_fluctuation (average, current_list_node);
					}
				}
			}
			else {
				/* We have a "BK" lesson from another section. */
				/* So, it will be inserted in "epiloghs" list. */
				insert_epiloghs_average_fluctuation (average, current_list_node);
			}
			break;
	}

	/* Free up temp memory used */
	LIST__Destroy (lista_BK_1);
	LIST__Destroy (lista_BK_2);
	LIST__Destroy (lista_BK_3);

}

void insert_epiloghs_average_fluctuation (FLUCTUATION_AVERAGEPTR average, LIST_NODEPTR current_list_node)
{
	const double syntelesths_epiloghs = 1.5;

	KEY_TYPE key = current_list_node->key_code;
	TREE_NODEPTR current_tree_node = current_list_node->lesson_node;
	LIST_NODEPTR temp_list_node;
	double grade;

	/*****************************************************************\
	* NOTE: Consider what happens if                                  *
	*       average->epiloghs->NUMBER_OF_LESSONS exceeds 11!          *
	\*****************************************************************/

	if (average->epiloghs->NUMBER_OF_ELEMENTS < 11) {
		LIST__Insert_node_at_front (average->epiloghs, key, current_tree_node);
		average->arithmiths += (double) syntelesths_epiloghs * current_tree_node->data->grade;
		average->paronomasths += (double) syntelesths_epiloghs;
		average->number_of_lessons++;
	}
	else {
		/* average->epiloghs->NUMBER_OF_ELEMENTS == 11 */
		grade = current_tree_node->data->grade;
		temp_list_node = average->epiloghs->HEAD;
		while (temp_list_node != average->epiloghs->NIL) {
			if (temp_list_node->lesson_node->data->grade < grade)
				break;
			temp_list_node = temp_list_node->next;
		}
		if (temp_list_node != average->epiloghs->NIL) {
			/* We found a lesson with smaller grade */
			LIST__Delete_node_according_to_key (average->epiloghs, temp_list_node->key_code);
			LIST__Insert_node_at_front (average->epiloghs, key, current_tree_node);
			average->arithmiths -= (double) syntelesths_epiloghs * temp_list_node->lesson_node->data->grade;
			average->arithmiths += (double) syntelesths_epiloghs * grade;
			/* average->epiloghs->NUMBER_OF_ELEMENTS = UNCHANGED = 11 */
		}
	}
}




/*

double calculate_average_fluctuation (TREEPTR Tree, KEY_TYPE period [ARRAY_SIZE], 
									  FLUCTUATION_AVERAGEPTR average)
{
	const double syntelesths_kormou = 2.0, syntelesths_basika = 2.0,
				syntelesths_epiloghs = 1.5, syntelesths_ptyxiakhs = 6.0;
	char barythta [BARYTHTA_BUFFER];
	int i;
	KEY_TYPE key;
	TREE_NODEPTR current;

	i = 0;
	while (period [i] != 0) {
		key = period [i];
		current = TREE__Search (Tree, key);
		strcpy (barythta, current->data->barythta);
		if (strcmp (barythta, "YP") == 0) {
			average->arithmiths += (double) syntelesths_kormou * current->data->grade;
			average->paronomasths += (double) syntelesths_kormou;
			average->number_of_lessons = average->number_of_lessons + 1;
		}
		if (strcmp (barythta, "BK") == 0) {
			average->arithmiths += (double) syntelesths_basika * current->data->grade;
			average->paronomasths += (double) syntelesths_basika;
			average->number_of_lessons = average->number_of_lessons + 1;
		}
		if (strcmp (barythta, "EP") == 0) {
			average->arithmiths += (double) syntelesths_epiloghs * current->data->grade;
			average->paronomasths += (double) syntelesths_epiloghs;
			average->number_of_lessons = average->number_of_lessons + 1;
		}
		if (strcmp (barythta, "PT") == 0) {
			average->arithmiths += (double) syntelesths_ptyxiakhs * current->data->grade;
			average->paronomasths += (double) syntelesths_ptyxiakhs;
			average->number_of_lessons = average->number_of_lessons + 1;
		}

		i++;	// Go to next lesson.
	}


	if (average->number_of_lessons == 0)
		average->average_grade = 0.0;
	else
		average->average_grade = (double) average->arithmiths / average->paronomasths;

	return (double) average->average_grade;
}


















/* Old Average calculation */
/***************************/


/*
AVERAGE_REPLYPTR calculate_average (TREEPTR Tree)
{
	/* DHLWSH STATHERWN */
/*	const int plh8os_kormou = 24;
	const int plh8os_basika = 5;
	const int plh8os_epiloghs = 11;
	const int plh8os_ptyxiakhs = 1;
	const double syntelesths_kormou = 2.0, syntelesths_basikwn = 2.0, syntelesths_epiloghs = 1.5;
	const double syntelesths_ptyxiakhs = 6.0;
	/* DHLWSH METABLHTWN */
/*	int kormou = 0, basika = 0, epiloghs = 0, ptyxiakh = 0;
	int i, counter_basika, counter_epiloghs;
	double kormou_grade [ARRAY_SIZE], basika_grade [ARRAY_SIZE], epiloghs_grade [ARRAY_SIZE];
	KEY_TYPE basika_code [ARRAY_SIZE];
	double ptyxiakh_grade;
	double current_grade;
	double arithmiths = 0.0, paronomasths = 0.0;
	char enter [REPLY_BUFFER];
	TREE_NODEPTR current_node;
	AVERAGE_REPLYPTR average = (AVERAGE_REPLYPTR) malloc (sizeof (AVERAGE_REPLY));
	double low_arithmiths, low_paronomasths;
	double high_arithmiths, high_paronomasths;
	/*********************/
/*
	for (i = 1; i <= kormou; i++) {
		arithmiths += (double) syntelesths_kormou * kormou_grade [i - 1];
		paronomasths += (double) syntelesths_kormou;
	}

	//QuickSort (basika_grade, 0, (basika - 1));	// Sort in decreasing order.
	QuickSort_double (basika_grade, 0, (basika - 1), basika_code);

	if (basika > 5) {
		for (i = 1; i <= 5; i++) {
			arithmiths += (double) syntelesths_basikwn * basika_grade [i - 1];
			paronomasths += (double) syntelesths_basikwn;
			average->basika [i - 1] = basika_code [i - 1];
		}
	}
	else {
		for (i = 1; i <= basika; i++) {
			arithmiths += (double) syntelesths_basikwn * basika_grade [i - 1];
			paronomasths += (double) syntelesths_basikwn;
			average->basika [i - 1] = basika_code [i - 1];
		}
	}

	if (basika > 5) {
		for (i = 1; i <= 5; i++)
			basika_grade [i - 1] = 0;
		basika -= 5;
	}
	else {
		for (i = 1; i <= basika; i++)
			basika_grade [i - 1] = 0;
		basika = 0;
	}
	QuickSort (basika_grade, 0, (basika - 1));

	QuickSort (epiloghs_grade, 0, (epiloghs - 1));


	counter_basika = 0;
	counter_epiloghs = 0;
	while ((counter_basika + counter_epiloghs) < plh8os_epiloghs) {
		if ((basika_grade [counter_basika] >= 5.0) || (epiloghs_grade [counter_epiloghs] >= 5.0)) {
			if (basika_grade [counter_basika] >= epiloghs_grade [counter_epiloghs]) {
				arithmiths += (double) syntelesths_epiloghs * basika_grade [counter_basika];
				counter_basika++;
			}
			else {
				arithmiths += (double) syntelesths_epiloghs * epiloghs_grade [counter_epiloghs];
				counter_epiloghs++;
			}
			paronomasths += (double) syntelesths_epiloghs;
		}
		else {
			break;
		}
	}


	if (ptyxiakh) {
		arithmiths += (double) syntelesths_ptyxiakhs * ptyxiakh_grade;
		paronomasths += (double) syntelesths_ptyxiakhs;
	}

	//printf ("Arithmitis  : %f\n", arithmiths);
	//printf ("Paronomasths: %f\n", paronomasths);
	//fflush (stdin);
	//gets (enter);

	average->arithmiths = arithmiths;
	average->paronomasths = paronomasths;
	average->average_grade = (double) arithmiths / paronomasths;

	if ((kormou == plh8os_kormou) && (basika >= plh8os_basika) && 
		((counter_basika + counter_epiloghs) == plh8os_epiloghs)) {
		/* MPOREIS NA PAREIS PTYXIO */
/*		average->get_ptyxio = 1;
	}
	else {
		/* DEN MPOREIS NA PAREIS AKOMA PTYXIO */
/*		average->get_ptyxio = 0;
	}


	if (average->get_ptyxio == 1) {
		average->lowest_grade = average->average_grade;
		average->highest_grade = average->average_grade;

		return average;		// Return average grade only and go to graduation.
	}


	/*
	 * Akolou8oun oi prakseis gia problepsh
	 * oriwn tou bathmou toy ptyxiou.
	 */

/*
	low_arithmiths = 0.0;
	low_paronomasths = 0.0;
	high_arithmiths = 0.0;
	high_paronomasths = 0.0;

	if (kormou < plh8os_kormou) {
		for (i = 1; i <= (plh8os_kormou - kormou); i++) {
			low_arithmiths += (double) syntelesths_kormou * 5;
			low_paronomasths += (double) syntelesths_kormou;
			high_arithmiths += (double) syntelesths_kormou * 10;
			high_paronomasths += (double) syntelesths_kormou;
		}
	}

	if (basika < plh8os_basika) {
		for (i = 1; i <= (plh8os_basika - basika); i++) {
			low_arithmiths += (double) syntelesths_basikwn * 5;
			low_paronomasths += (double) syntelesths_basikwn;
			high_arithmiths += (double) syntelesths_basikwn * 10;
			high_paronomasths += (double) syntelesths_basikwn;
		}
	}

	if ((counter_basika + counter_epiloghs) < plh8os_epiloghs) {
		for (i = 1; i <= (plh8os_epiloghs - (counter_basika + counter_epiloghs)); i++) {
			low_arithmiths += (double) syntelesths_epiloghs * 5;
			low_paronomasths += (double) syntelesths_epiloghs;
			high_arithmiths += (double) syntelesths_epiloghs * 10;
			high_paronomasths += (double) syntelesths_epiloghs;
		}
	}

	if (!ptyxiakh) {
		low_arithmiths += (double) syntelesths_ptyxiakhs * 10;
		low_paronomasths += (double) syntelesths_ptyxiakhs;
		high_arithmiths += (double) syntelesths_ptyxiakhs * 10;
		high_paronomasths += (double) syntelesths_ptyxiakhs;
	}

	average->lowest_grade = (double) (arithmiths + low_arithmiths) / (paronomasths + low_paronomasths);
	average->highest_grade = (double) (arithmiths + high_arithmiths) / (paronomasths + high_paronomasths);

	return average;		// Return average grade with predictions.
}
*/


/* END OF Old Average calculation */
/**********************************/
