#include "menus.h"

/*********************************************************/

int file_creation_menu ()
{
	char reply_string [REPLY_BUFFER];
	char reply = 'a';

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("File %s could not be opened.\n", DEFAULT_DATA_FILENAME);
		printf ("Do you want to create %s file?\n", DEFAULT_DATA_FILENAME);
		printf ("(y = YES, n = NO) ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply_string);
		if (strlen (reply_string) != 1)
			reply = 'a';
		else
			reply = reply_string [0];
	} while ((reply != 'y') && (reply != 'n') && 
			(reply != 'Y') && (reply != 'N'));

	if ((reply == 'y') || (reply == 'Y'))
		return 1;	// Indicate to create file.
	else
		return 0;	// Indicate not to create file.
}

/*********************************************************/

void show_logo ()
{
	printf ("***********************************************\n");
	printf ("* UNIVERSITY OF ATHENS                        *\n");
	printf ("* DEPT. OF INFORMATICS AND TELECOMMUNICATIONS *\n");
	printf ("***********************************************\n");
	printf ("\n\n");
	fflush (stdout);
}

KEY_TYPE main_menu (int elements)
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("MAIN MENU - Analytikh Bathmologia - (%d)\n", elements);
		printf ("----------------------------------------\n");
		printf ("  1. Insert new record.\n");
		printf ("  2. Delete one record.\n");
		printf ("  3. Update one record.\n");
		printf ("  4. Search for a specific record.\n");
		printf ("  5. Show all records.\n");
		printf ("  6. Tree Representation in Memory.\n");
		printf ("  7. Calculate average grade.\n");
		printf ("  8. Display various statistics.\n");
		printf ("  9. Create Text Files for printing.\n");
		printf (" 10. Update Data File.\n");
		printf (" 11. HELP.\n");
		printf (" 12. EXIT PROGRAM.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 12, selection));

	return selection;
}

KEY_TYPE insert_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("INSERTION MENU\n");
		printf ("--------------\n");
		printf (" 1. Procceed to insert new record.\n");
		printf (" 2. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 2, selection));

	return selection;
}

KEY_TYPE delete_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("DELETE MENU\n");
		printf ("-----------\n");
		printf (" 1. Delete one record according to a specific KEY (lesson code) code.\n");
		printf (" 2. Traverse (inOrder) the records and select which record to delete.\n");
		printf (" 3. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 3, selection));

	return selection;
}

KEY_TYPE update_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("UPDATE MENU\n");
		printf ("-----------\n");
		printf (" 1. Update one record according to a specific KEY (lesson code) code.\n");
		printf (" 2. Traverse (inOrder) the records and select which record to update.\n");
		printf (" 3. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 3, selection));

	return selection;
}

KEY_TYPE search_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("SEARCH FOR A SPECIFIC RECORD MENU\n");
		printf ("---------------------------------\n");
		printf (" 1. Search for a specific record according to a KEY (lesson code) code.\n");
		printf (" 2. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 2, selection));

	return selection;
}

KEY_TYPE show_all_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("SHOW ALL RECORDS MENU\n");
		printf ("---------------------\n");
		printf (" 1. Show all records inOrder.\n");
		printf (" 2. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 2, selection));

	return selection;
}

KEY_TYPE tree_representation_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("TREE REPRESENTATION MENU\n");
		printf ("------------------------\n");
		printf (" 1. Show Tree's Nodes and Leaves with their corresponding Keys.\n");
		printf (" 2. Show Tree's Nodes and Leaves with their corresponding Colors.\n");
		printf (" 3. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 3, selection));

	return selection;
}

KEY_TYPE fluctuation_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("AVERAGE GRADE FLUCTUATION MENU\n");
		printf ("------------------------------\n");
		printf (" 1. Show Fluctuation of Average Grade following 1st Section.\n");
		printf (" 2. Show Fluctuation of Average Grade following 2nd Section.\n");
		printf (" 3. Show Fluctuation of Average Grade following 3rd Section.\n");
		printf (" 4. Show Fluctuation of Average Grade without following a particular Section.\n");
		printf (" 5. Return to Statistics Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 5, selection));

	return selection;
}


KEY_TYPE statistics_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("STATISTICS MENU\n");
		printf ("---------------\n");
		printf (" 1. Show Average Grade of Lessons passed per Examination Period.\n");
		printf (" 2. Select which Section you want to follow and then show Fluctuation of\n");
		printf ("    Average Grade during Examination Periods.\n");
		printf (" 3. Show Number and Kind of Lessons passed per Examination Period.\n");
		printf (" 4. Select which Kind of Lessons you want to spy and then show the number of\n");
		printf ("    these Lessons per grade.\n");
		printf (" 5. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 5, selection));

	return selection;
}

KEY_TYPE lesson_grades_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("LESSONS PER GRADE MENU\n");
		printf ("----------------------\n");
		printf (" 1. Show number of \"YP\" Lessons passed per grade.\n");
		printf (" 2. Show number of \"BK\" Lessons passed per grade.\n");
		printf (" 3. Show number of \"EP\" Lessons passed per grade.\n");
		printf (" 4. Show number of Lessons (Overall) passed per grade.\n");
		printf (" 5. Return to Statistics Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 5, selection));

	return selection;
}

KEY_TYPE create_lesson_grades_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("CREATE LESSONS PER GRADE FILES MENU\n");
		printf ("-----------------------------------\n");
		printf (" 1. Create Text File with number of \"YP\" Lessons passed per grade.\n");
		printf (" 2. Create Text File with number of \"BK\" Lessons passed per grade.\n");
		printf (" 3. Create Text File with number of \"EP\" Lessons passed per grade.\n");
		printf (" 4. Create Text File with number of Lessons (Overall) passed per grade.\n");
		printf (" 5. Return to File Creation Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 5, selection));

	return selection;
}


KEY_TYPE create_fluctuation_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("CREATE AVERAGE GRADE FLUCTUATION FILE MENU\n");
		printf ("------------------------------------------\n");
		printf (" 1. Create Text File with Average Fluctuation based on 1st Section Graduation.\n");
		printf (" 2. Create Text File with Average Fluctuation based on 2nd Section Graduation.\n");
		printf (" 3. Create Text File with Average Fluctuation based on 3rd Section Graduation.\n");
		printf (" 4. Create Text File with Average Fluctuation based on Uni-Section Graduation.\n");
		printf (" 5. Return to File Creation Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 5, selection));

	return selection;
}

KEY_TYPE create_files_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("FILE CREATION MENU\n");
		printf ("------------------\n");
		printf (" 1. Create Text File with All Lessons Passed so far.\n");
		printf (" 2. Create Text File with Average Grade.\n");
		printf (" 3. Create Text File with Lessons Passed per Examination Period.\n");
		printf (" 4. Create Text File with Average Grade of Lessons passed per Examination\n");
		printf ("    Period.\n");
		printf (" 5. Select the Section you want to follow and then create Text File with\n");
		printf ("    Average Grade Fluctuation.\n");
		printf (" 6. Select the Kind of Lessons you want to spy and then create Text File\n");
		printf ("    with the Number of these Lessons passed per particular grade.\n");
		printf (" 7. Create Text File with Keys on Nodes and Leaves in Tree.\n");
		printf (" 8. Create Text File with Colors on Nodes and Leaves in Tree.\n");
		printf (" 9. Create Text File with Keys-Colors on Nodes and Leaves in Tree.\n");
		printf ("10. Create Text File with General Help about this program.\n");
		printf ("11. Create Text File with Modifications from previous versions of this program.\n");
		printf ("12. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 12, selection));

	return selection;
}

KEY_TYPE update_datafile_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("UPDATE DATAFILE MENU\n");
		printf ("--------------------\n");
		printf (" 1. Fast update.\n");
		printf (" 2. Secure update.\n");
		printf (" 3. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 3, selection));

	return selection;
}

KEY_TYPE help_menu ()
{
	KEY_TYPE selection;
	char reply [REPLY_BUFFER];

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("HELP MENU\n");
		printf ("---------\n");
		printf (" 1. General Help...\n");
		printf (" 2. About...\n");
		printf (" 3. Modifications from Previous Versions (current version 3.21).\n");
		printf (" 4. Return to Main Menu.\n");
		printf ("\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply);
		if (numeric_int (reply))
			selection = atol (reply);
		else
			selection = 0;
	} while (!in_range (1, 4, selection));

	return selection;
}

/*********************************************************/

int numeric_int (char *s)
{
	int length, incorrect, i;

	incorrect = 0;			// So far correct.
	length = strlen (s);	// String length.

	for (i = 0; i <= (length - 1); i++) {
		if (!isdigit (s [i])) {
			incorrect = 1;	// Incorrect string entry.
			break;
		}
	}

	if (incorrect)
		return 0;	// Not a numeric (integer) string.
	else
		return 1;	// Correct numeric (integer) string.
}

int in_range (const KEY_TYPE lower_bound, const KEY_TYPE upper_bound, const KEY_TYPE selection)
{
	KEY_TYPE i, in_range_selection = 0;

	for (i = lower_bound; i <= upper_bound; i++) {
		if (i == selection) {
			in_range_selection = 1;
			break;
		}
	}

	if (in_range_selection)
		return 1;	// Selection is in range.
	else
		return 0;	// Selection out of range.
}

/*********************************************************/

int verify_exit ()
{
	char reply_string [REPLY_BUFFER];
	char reply;

	do {
		CLEARSCREEN;
		show_logo ();
		printf ("You have made some changes during your last session.\n");
		printf ("Are you sure you want to leave without saving these changes?\n");
		printf ("Y = YES Quit program and lose changes.\n");
		printf ("N = NO, Return to Main Menu to Update Data File.\n");
		printf ("\n");
		printf ("? ");
		fflush (stdout);
		fflush (stdin);
		gets (reply_string);
		if (strlen (reply_string) != 1)
			reply = 'a';
		else
			reply = reply_string [0];
	} while ((reply != 'y') && (reply != 'n') && 
			(reply != 'Y') && (reply != 'N'));

	if ((reply == 'y') || (reply == 'Y'))
		return 1;	// Verify Exit NOW!
	else
		return 0;	// Exit NOW was NOT VERIFIED!
}

/*********************************************************/

void general_screen (FILE *ekei)
{
	fprintf (ekei, "***********************************************\n");
	fprintf (ekei, "* UNIVERSITY OF ATHENS                        *\n");
	fprintf (ekei, "* DEPT. OF INFORMATICS AND TELECOMMUNICATIONS *\n");
	fprintf (ekei, "***********************************************\n");
	fprintf (ekei, "\n\n");
	fprintf (ekei, "GENERAL HELP - Analytikh Bathmologia\n");
	fprintf (ekei, "------------------------------------\n");
	fprintf (ekei, "-> Ola ta dedomena fortwnontai apo to arxeio \"grades.dat\" kai fylassontai\n");
	fprintf (ekei, "   sthn kyria mnhmh toy ypologisth (RAM). To arxeio ayto prepei na brisketai\n");
	fprintf (ekei, "   ston idio katalogo me to programma to opoio trexete ayth th stigmh.\n");
	fprintf (ekei, "-> Opoiesdhpote allages kanete stis eggrafes ginontai ap'ey8eias sth RAM gia\n");
	fprintf (ekei, "   megalyterh taxythta. Apla prin kleisete to programma, an exete kanei kapoies\n");
	fprintf (ekei, "   allages, swste tis allages aytes kanontas Update to arxeio me ta dedomena.\n");
	fprintf (ekei, "   Se periptwsh pou to ksexasete kai epixeirhsete na bgeite apo to programma,\n");
	fprintf (ekei, "   ayto 8a sas to ypen8ymisei kata thn eksodo.\n");
	fprintf (ekei, "-> Ta ma8hmata eisagontai se ena KOKKINO-MAYRO Dentro (RED-BLACK Tree) wste\n");
	fprintf (ekei, "   na eksasfalizetai oti oi diadikasies Insert, Search, Update kai Delete\n");
	fprintf (ekei, "   xreiazontai O(lg{n}) xrono.\n");
	fprintf (ekei, "-> To programma ayto PERIEXEI BUGS. Ean breite kati to opoio pragmatika aksizei\n");
	fprintf (ekei, "   na anaferete, parakalw epikoinwnhste mazi mou sthn hlektronikh diey8ynsh pou\n");
	fprintf (ekei, "   brisketai sthn o8onh HELP->ABOUT.\n");
	fprintf (ekei, "-> O syntelesths barythtatas enos ma8hmatos pairnei mia apo tis parakatw times:\n");
	fprintf (ekei, "   YP = YPOXREWTIKO, BK = BASIKO KATEYTHYNSHS, EP = EPILOGHS, PT = PTYXIAKH\n");
	fprintf (ekei, "-> Egkyroi kwdikoi ma8hmatwn 8ewrountai aytoi pou exoun timh: [100000, 101000].\n");
	fprintf (ekei, "-> Na symplhrwnete ola ta pedia twn eggrafwn opws ayta sas parexontai apo th\n");
	fprintf (ekei, "   grammateia, wste to programma na mporei na leitourgei swsta kai na exete th\n");
	fprintf (ekei, "   dynatothta na deite ta endiaferonta (kata th gnwmh mou) statistika stoixeia.\n");
	fprintf (ekei, "-> Gia ma8hmata ektos Sxolhs (opws Fysikh kai Ma8hmatika) na ta kataxwreite\n");
	fprintf (ekei, "   ston tomea 0 (mhden), wste na pairnete swsta ta diafora statistika stoixeia\n");
	fprintf (ekei, "   apo tis diafores synarthseis pou xrhsimopoiountai.\n");
	fprintf (ekei, "-> Synistwmenes grammatoseires gia ektypwsh twn arxeiwn: Courier New (9).\n");
	fprintf (ekei, "-> Ta diafora arxeia pou mporeite na dhmiourghsete (TEXT) exoun tis akolou8es\n");
	fprintf (ekei, "   onomasies:\n");
	fprintf (ekei, "   Analytikh Bathmologia                : \"analytikh.txt\"\n");
	fprintf (ekei, "   Trexwn Mesos Oros                    : \"average.txt\"\n");
	fprintf (ekei, "   Statistikh Ma8hmatwn ana Eksetastikh : \"lesson_stats.txt\"\n");
	fprintf (ekei, "   Mesos Oros Eksetastikhs              : \"average_stats.txt\"\n");
	fprintf (ekei, "   Diakymansh Mesou Orou...\n");
	fprintf (ekei, "    -> Xwris Epilogh Katey8ynshs        : \"uni-section_average_fluctuation.txt\"\n");
	fprintf (ekei, "    -> Akolou8wntas 1o Tomea            : \"1st_section_average_fluctuation.txt\"\n");
	fprintf (ekei, "    -> Akolou8wntas 2o Tomea            : \"2nd_section_average_fluctuation.txt\"\n");
	fprintf (ekei, "    -> Akolou8wntas 3o Tomea            : \"3rd_section_average_fluctuation.txt\"\n");
	fprintf (ekei, "   Statistikh Ma8hmatwn ana Bathmo...\n");
	fprintf (ekei, "    -> Ypoxrewtika Ma8hmata ana Bathmo  : \"ypoxrewtika_per_grade.txt\"\n");
	fprintf (ekei, "    -> Basika Ma8hmata ana Bathmo       : \"basika_per_grade.txt\"\n");
	fprintf (ekei, "    -> Epiloghs Ma8hmata ana Bathmo     : \"epiloghs_per_grade.txt\"\n");
	fprintf (ekei, "    -> Ola ta Ma8hmata ana Bathmo       : \"lessons_per_grade.txt\"\n");
	fprintf (ekei, "   Katastash Dentrou Eggrafwn sth RAM...\n");
	fprintf (ekei, "    -> Dentro me Kleidia                : \"tree_keys.txt\"\n");
	fprintf (ekei, "    -> Dentro me Xrwmata                : \"tree_colors.txt\"\n");
	fprintf (ekei, "    -> Dentro me Kleidia kai Xrwmata    : \"tree.txt\"\n");
	fprintf (ekei, "   Diafora Boh8htika Arxeia...\n");
	fprintf (ekei, "    -> Genikh Boh8eia gia to programma  : \"general_help.txt\"\n");
	fprintf (ekei, "    -> Allages apo prohgoumenes ekdoseis: \"modifications.txt\"\n\n");
	fprintf (ekei, "D.J.D.\n");
	fflush (ekei);
}

void about_screen ()
{
	CLEARSCREEN;
	show_logo ();

	printf ("ANALYTIKH BATHMOLOGIA\n");
	printf ("---------------------\n");
	printf ("Version: 3.21\n");
	printf ("Author : Dimitris Diochnos\n");
	printf ("\n");
	printf ("NOTE: If you want to report bugs, bugfixes,\n");
	printf ("or if you have any questions at all, you can\n");
	printf ("contact me at: stud1098@di.uoa.gr\n");
	printf ("        or at: dimis_diochnos@hotmail.com\n");
	printf ("    or at UIN: 1628127  (ICQ)\n");
	fflush (stdout);
}

void modifications_screen (FILE *ekei)
{
	fprintf (ekei, "***********************************************\n");
	fprintf (ekei, "* UNIVERSITY OF ATHENS                        *\n");
	fprintf (ekei, "* DEPT. OF INFORMATICS AND TELECOMMUNICATIONS *\n");
	fprintf (ekei, "***********************************************\n");
	fprintf (ekei, "\n\n");
	fprintf (ekei, "MODIFICATIONS FROM PREVIOUS VERSIONS - Analytikh Bathmologia\n");
	fprintf (ekei, "------------------------------------------------------------\n");
	fprintf (ekei, "-> Version 1.01\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Released 10 August 2001.\n\n");
	fprintf (ekei, "-> Version 2.01\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Allowed Tree Representation on screen (KEY-COLOR).\n");
	fprintf (ekei, "   Created and Released 22 February 2002.\n\n");
	fprintf (ekei, "-> Version 2.11\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Allowed Enhanced Tree Represantation on screen.\n");
	fprintf (ekei, "   Allowed Enhanced Tree Represantation on files.\n");
	fprintf (ekei, "   Created and Released 23 February 2002.\n\n");
	fprintf (ekei, "-> Version 2.12\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Fixed indent (2) when creating text with KEY-COLOR characteristics.\n");
	fprintf (ekei, "   Shows numerator and denominator when displaying average grade.\n");
	fprintf (ekei, "   Shows basic-lessons' codes when calculating average grade.\n");
	fprintf (ekei, "   Created and Released 24 February 2002.\n\n");
	fprintf (ekei, "-> Version 2.21\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Allowed Visual and Text Output for the Number of Lessons Passed per Grade.\n");
	fprintf (ekei, "   Created and Released 30 March 2002.\n\n");
	fprintf (ekei, "-> Version 2.22\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Fixed bug when showing (or writing) various stats, when last examination\n");
	fprintf (ekei, "   period is either February or June. The foregoing examination periods are\n");
	fprintf (ekei, "   not shown.\n");
	fprintf (ekei, "   Created and Released 1 April 2002.\n\n");
	fprintf (ekei, "-> Version 3.14159...\n");
	fprintf (ekei, "   ------------------\n");
	fprintf (ekei, "   Fixed function that calculated average grade.\n");
	fprintf (ekei, "   Allowed Enhanced Statistics based on the Section someone wants to follow.\n");
	fprintf (ekei, "   Created during 1 - 7 April 2002.\n");
	fprintf (ekei, "   Released 7 April 2002.\n\n");
	fprintf (ekei, "-> Version 3.21\n");
	fprintf (ekei, "   ------------\n");
	fprintf (ekei, "   Fixed bug in statistics windows (Non-Increasing order of years shown).\n");
	fprintf (ekei, "   Created and Released 13 June 2002.\n");
	fflush (ekei);
}

/*********************************************************/