#if !defined PREPROCCESSOR_DEFINITIONS
#define PREPROCCESSOR_DEFINITIONS

/*********************************************************/

/* An xrhsimopoieite WINDOWS afhste to arxeio opws einai. */

/********************************************\
* Necessary for "system" function in WINDOWS *
\********************************************/

	#include <process.h>

	/* Commands in WINDOWS */

	#define CLEARSCREEN system ( "cls" )
	#define CREATE_BACKUP_FILE system ( "ren grades.dat grades.old" )
	#define DELETE_BACKUP_FILE system ( "del grades.old" )

/*********************************************************/

/*********************************************************\
* An xrhsimopoieite LINUX - UNIX afaireste ta sxolia stis *
* parakatw grammes kai balte sxolia stis prohgoumenes.    *
\*********************************************************/

	/* Commands in LINUX - UNIX */
/*
	#define CLEARSCREEN system ( "clear" )
	#define CREATE_BACKUP_FILE system ( "mv -f grades.dat grades.old" )
	#define DELETE_BACKUP_FILE system ( "rm -f grades.old" )
*/

/*********************************************************/

#include <stdio.h>		// Necessary for various "printf", "gets", etc. functions.
#include <string.h>		// Necessary for "strlen" function.
#include <stdlib.h>		// Necessary for "atoi" function.
#include <ctype.h>		// Necessary for "isdigit" function.
#include <math.h>		// Necessary in "average.h"
#include <malloc.h>

/*********************************************************/

typedef long int KEY_TYPE;

/*********************************************************/

#define KEY_DISPLAY_INDENT 8
#define COLOR_DISPLAY_INDENT 7
#define REPLY_BUFFER 32
#define ARRAY_SIZE 24

/*********************************************************/

#define DEFAULT_DATA_FILENAME "grades.dat"

#define LOWER_BOUND_CODE 100000
#define UPPER_BOUND_CODE 101000

/*********************************************************/

#define FILENAME_BUFFER 64
#define FIRSTNAME_BUFFER 32
#define LASTNAME_BUFFER 32
#define ENTRYDATE_BUFFER 11
#define BIRTHDAY_BUFFER 11
#define ID_BUFFER 5

#define DEFAULT_TEXT_FILENAME "analytikh.txt"
#define DEFAULT_AVERAGE_FILENAME "average.txt"
#define DEFAULT_LESSON_STATS_FILENAME "lesson_stats.txt"
#define DEFAULT_AVERAGE_STATS_FILENAME "average_stats.txt"
#define DEFAULT_UNISECTION_AVERAGE_FLUCTUATION_FILENAME "uni-section_average_fluctuation.txt"
#define DEFAULT_FIRST_SECTION_AVERAGE_FLUCTUATION_FILENAME "1st_section_average_fluctuation.txt"
#define DEFAULT_SECOND_SECTION_AVERAGE_FLUCTUATION_FILENAME "2nd_section_average_fluctuation.txt"
#define DEFAULT_THIRD_SECTION_AVERAGE_FLUCTUATION_FILENAME "3rd_section_average_fluctuation.txt"
#define DEFAULT_TREE_KEYS_FILENAME "tree_keys.txt"
#define DEFAULT_TREE_COLORS_FILENAME "tree_colors.txt"
#define DEFAULT_TREE_FILENAME "tree.txt"
#define DEFAULT_GENERAL_HELP_FILENAME "general_help.txt"
#define DEFAULT_MODIFICATIONS_FILENAME "modifications.txt"
#define DEFAULT_YPOXREWTIKA_PER_GRADE_FILENAME "ypoxrewtika_per_grade.txt"
#define DEFAULT_BASIKA_PER_GRADE_FILENAME "basika_per_grade.txt"
#define DEFAULT_EPILOGHS_PER_GRADE_FILENAME "epiloghs_per_grade.txt"
#define DEFAULT_LESSONS_PER_GRADE_FILENAME "lessons_per_grade.txt"

/*********************************************************/

enum Main_Choices { INSERT_RECORD = 1, DELETE_RECORD, UPDATE_RECORD, 
					SEARCH, SHOW_ALL_RECORDS, DISPLAY_TREE, CALCULATE_AVERAGE, DISPLAY_STATISTICS, 
					CREATE_TEXTFILE, UPDATE_DATAFILE, HELP, EXIT_PROGRAM };

enum Insert_Choices { PROCCEED_INSERT = 1, EXIT_INSERT };

enum Delete_Choices { KEY_DELETE = 1, TRAVERSE_AND_DELETE, EXIT_DELETE };

enum Statistics_Choices { PERIOD_AVERAGE = 1, AVERAGE_FLUCTUATION, PERIOD_LESSONS, 
							LESSONS_GRADES, EXIT_STATISTICS };

enum Fluctuation_Menu_Choices { DISPLAY_FIRST_SECTION_FLUCTUATION = 1, 
								DISPLAY_SECOND_SECTION_FLUCTUATION, DISPLAY_THIRD_SECTION_FLUCTUATION, 
								DISPLAY_UNISECTION_FLUCTUATION,	EXIT_FLUCTUATION_MENU };

enum Lessons_Per_Grade_Choices { YPOXREWTIKA_MA8HMATA = 1, BASIKA_MA8HMATA, EPILOGHS_MA8HMATA, 
									OLA_TA_MA8HMATA, EXIT_LESSON_GRADES_MENU };

enum Create_Lessons_Per_Grade { CREATE_YPOXREWTIKA_MA8HMATA = 1, CREATE_BASIKA_MA8HMATA, 
								CREATE_EPILOGHS_MA8HMATA, CREATE_OLA_TA_MA8HMATA, 
								EXIT_CREATE_LESSON_GRADES_MENU };

enum Update_Choices { KEY_UPDATE = 1, TRAVERSE_AND_UPDATE, EXIT_UPDATE };

enum Show_All_Choices { SHOW_ALL = 1, EXIT_SHOW_ALL };

enum Search_Choices { SEARCH_FOR_RECORD = 1, EXIT_SEARCH };

enum Display_Tree_Choices { KEY_DISPLAY = 1, COLOR_DISPLAY, EXIT_DISPLAY};

enum Create_Choices { CREATE_ANALYTIKH = 1, CREATE_AVERAGE, CREATE_LESSON_STATS, 
						CREATE_AVERAGE_PERIOD, CREATE_AVERAGE_FLUCTUATION, 
						CREATE_LESSONS_PER_GRADE, CREATE_TREE_KEYS, 
						CREATE_TREE_COLORS, CREATE_TREE, CREATE_GENERAL_HELP, 
						CREATE_MODIFICATIONS, EXIT_CREATE };

enum Create_Fluctuation_Choices { FIRST_SECTION_FLUCTUATION = 1, SECOND_SECTION_FLUCTUATION, 
									THIRD_SECTION_FLUCTUATION, UNISECTION_FLUCTUATION, EXIT_FLUCTUATION};

enum Update_Datafile_Choices { FAST_UPDATE = 1, SECURE_UPDATE, EXIT_UPDATE_DATAFILE };

enum Help_Choices { GENERAL = 1, ABOUT, MODIFICATIONS, EXIT_HELP };

/*********************************************************/

#endif