#if !defined RB_TREES_H
#define RB_TREES_H

/*********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "prep_defs.h"

/*********************************************************/

#define LESSON_NAME_BUFFER 64
#define DATE_PASSED_BUFFER 11
#define AKADHMAIKO_ETOS_BUFFER 8
#define BARYTHTA_BUFFER 3

#if !defined( NULL_KEY )
	#define NULL_KEY -1000
#endif

/*********************************************************/

/*******************************************************\
* Epeidh ekane conflict sto project peri Analytikhs     *
* Bathmologias, gia to logo ayto edw apotelei sxolio    *
* Par'ola ayta ta rb-trees.* mporoun na xrhsimopoih8oun *
* kai se allo project xwris to prep_defs.h, para mono   *
* bgazontas ta parakatw sxolia                          *
\*******************************************************/

	/****************************\
	* typedef long int KEY_TYPE; *
	\****************************/

/*********************************************************/

typedef int COLOR_TYPE;
enum Tree_Colors { RED = 1, BLACK };

/*********************************************************/

struct data_structure {
	KEY_TYPE code;
	char lesson [LESSON_NAME_BUFFER];
	double grade;
	char date_passed [DATE_PASSED_BUFFER];
	char akadhmaiko_etos [AKADHMAIKO_ETOS_BUFFER];
	int semester;
	char barythta [BARYTHTA_BUFFER];
	int section;
};

typedef struct data_structure DATA_TYPE;
typedef DATA_TYPE *DATA_TYPEPTR;

struct tree_node {
	KEY_TYPE key;
	struct tree_node *left_child;
	COLOR_TYPE color;
	DATA_TYPEPTR data;
	struct tree_node *right_child;
	struct tree_node *parent;
};

typedef struct tree_node TREE_NODE;
typedef TREE_NODE *TREE_NODEPTR;

struct tree {
	TREE_NODEPTR ROOT;
	TREE_NODEPTR NIL;	/* This is used as a sentinel. */
};

typedef struct tree TREE;
typedef TREE *TREEPTR;

/*********************************************************/

int REALLOCATE__DATA_KEY (TREE_NODEPTR source, TREE_NODEPTR target);

/*********************************************************/

TREEPTR TREE__Create ();
TREE_NODEPTR TREE_NODE__Create (TREEPTR Tree);
int TREE_NODE__Destroy (TREE_NODEPTR OldNode);
TREE_NODEPTR TREE__Search (TREEPTR Tree, KEY_TYPE k);
TREE_NODEPTR TREE__Minimum (TREEPTR Tree, TREE_NODEPTR x);
TREE_NODEPTR TREE__Maximum (TREEPTR Tree, TREE_NODEPTR x);
TREE_NODEPTR TREE__Successor (TREEPTR Tree, TREE_NODEPTR x);
TREE_NODEPTR TREE__Predecessor (TREEPTR Tree, TREE_NODEPTR x);

/*****************************************************************************/

int TREE__Insert (TREEPTR Tree, TREE_NODEPTR new_node);

/*****************************************************************************/

int LEFT__Rotate (TREEPTR Tree, TREE_NODEPTR x);
int RIGHT__Rotate (TREEPTR Tree, TREE_NODEPTR y);

int RED_BLACK__Insert (TREEPTR Tree, TREE_NODEPTR x);
TREE_NODEPTR RED_BLACK__Delete (TREEPTR Tree, TREE_NODEPTR z);
int RED_BLACK__Delete_FIXUP (TREEPTR Tree, TREE_NODEPTR x);

/*****************************************************************************/

#endif